#! /bin/bash
# Feb 20 2014 v1.0  -  added extra buttons
# Feb 24 v1.1  - gettext of lines - formulas added
# Feb 27 v1.2  - finished reference section
# march 11 v1.3  - new categories added
# march 12 v1.4  - put temporary files in folder
# march 13 v1.5   -  custom now possible
# march 15 v1.6   -  xmessage changed to Xdialog
# march 16 v1.7   -  default entry put in inputbox
export TEXTDOMAIN=PuppyUnits.sh
export OUTPUT_CHARSET=UTF-8
VERSION=1.7


export WORKDIR=/tmp/Puppyunits
mkdir -p $WORKDIR
rm -f $WORKDIR/combined
rm -f $WORKDIR/combined2
rm -f $WORKDIR/combined3
rm -f $WORKDIR/combined4
echo "" > $WORKDIR/result
# set up a custom conversion factor
[ ! -e /root/.config/Puppyunits/custom ] && echo "4.7" > /root/.config/Puppyunits/custom

###############################################
#                                             #
#                Geometry                     #
#                                             #
###############################################

# lines 21-110  makes a file  /tmp/combined which will be used for 'Geometry'

echo "$(gettext 'Geometry formulas')
$(gettext '1) The sum of the measures of the interior angles  
of an n-sided convex polygon = (n-2)180')
$(gettext '2) The sum of the measures of the exterior angles 
of any convex polygon is constant, 360.')
$(gettext '3) The area of a rectangle:')
_INSERT_
$(gettext '4a) The area of a square:')
_INSERT_
$(gettext '4b) The area of a square:')
_INSERT_
$(gettext '5a) The area of any triangle:')
_INSERT_ $(gettext 'where b is the base and h is the altitude.')
$(gettext '5b) The area of any triangle:')
_INSERT_
$(gettext '5c) The area of any triangle:')
_INSERT_ $(gettext 'where s =  1/2 (a + b + c)')
$(gettext '5d) The area of a right triangle:')
_INSERT_ $(gettext 'where l is a leg')
$(gettext '5e) The area of an equilateral triangle:')
_INSERT_ $(gettext 'where s is any side.')
$(gettext '5f) The area of an equilateral triangle:')
_INSERT_ $(gettext 'where h is any side.')
$(gettext '6a) The area of an equilateral triangle:')
_INSERT_
$(gettext '6b) The area of a parallelogram:')
_INSERT_
$(gettext '7) The area of a rhombus:')
_INSERT_
$(gettext '8) The area of a trapezoid:')
_INSERT_
$(gettext '9) The area of a regular polygon:')
_INSERT_ $(gettext 'where a is the apothem and p is the perimeter.')
$(gettext '10) The area of a circle:')
_INSERT_ $(gettext 'where d is the diameter.')
$(gettext '11) The area of a sector of a circle:')
_INSERT_ $(gettext 'where n is the measure of the central angle.')
$(gettext '12) The circumference of a circle:')
_INSERT_
$(gettext '13) The length of an arc of a circle:')
_INSERT_ 
$(gettext 'where n is the measure of the central angle of the arc.')
$(gettext '14) The volume of a sphere:')
_INSERT_
$(gettext '15) The area of surface of a sphere:')
_INSERT_
$(gettext '16) The volume of the right circular cylinder:')
_INSERT_ 
$(gettext '17) The volume of the right circular cone:')
_INSERT_
$(gettext '18) The lateral surface area of right circular cone:')
_INSERT_ $(gettext 'where s is the slant height.')
$(gettext '19) The volume of a frustrum of a cone:')
_INSERT_
$(gettext '20) The lateral surface area of a frustrum of a cone:')
_INSERT_ $(gettext 'where s is the slant height.')
$(gettext '21) The volume of a prism:')
_INSERT_ $(gettext 'where B is the area of the base')
$(gettext '22) The volume of a prism:')
_INSERT_"> /root/.config/Puppyunits/text-ascii

cp -f /root/.config/Puppyunits/text-ascii $WORKDIR/text-ascii
cp -f /root/.config/Puppyunits/formula-utf8 $WORKDIR/formula-utf8


cd $WORKDIR  # now add utf8 lines to text-ascii
cat text-ascii |
while read LINE;do
echo "$LINE" | grep -q "_INSERT_"
if [ "$?" -eq 0 ];then
if [ "${LINE}" = "_INSERT_" ];then  # just the utf-8 insertion
 read LINE_utf8 < formula-utf8
sed -i '1d' formula-utf8
echo $LINE_utf8 >> combined

elif [ "${LINE: -8}" = "_INSERT_" ];then  #  utf-8 at end
 read LINE_utf8 < formula-utf8
sed -i '1d' formula-utf8
echo "${LINE/_INSERT_/} $LINE_utf8" >> combined
else
 read LINE_utf8 < formula-utf8   # utf-8 at beginning
sed -i '1d' formula-utf8
echo "$LINE_utf8 ${LINE/_INSERT_/}" >> combined
fi
else
echo $LINE >> combined  #  no utf-8 used
fi
done


###############################################
#                                             #
#                 Algebra                     #
#                                             #
###############################################
# combined file for Geometry is created,  now combined2 is created
# for Algebra  -   text-ascii-2  is used

echo "$(gettext 'Equations of Curves:')
$(gettext 'Circle') _INSERT_
$(gettext 'Ellipse') _INSERT_
$(gettext 'Distance from center to focus') _INSERT_
$(gettext 'Hyperbola') _INSERT_
$(gettext 'Distance from center to focus') _INSERT_
$(gettext 'Parabola') _INSERT_

$(gettext 'Algebra formulas')
_INSERT_
_INSERT_
_INSERT_
$(gettext '1) The factor formula:')
_INSERT_
$(gettext '2) Binomial formula:')
_INSERT_
_INSERT_
$(gettext '3) Quadratic equation:')
_INSERT_
_INSERT_

_INSERT_
$(gettext 'when a,b,c are real')
       _INSERT_
       _INSERT_
       _INSERT_
      
_INSERT_   
$(gettext 'Product of roots is c/a')

$(gettext 'Logarithms')
_INSERT_ 
_INSERT_ 
$(gettext 'Laws of Logarithms')
_INSERT_
_INSERT_
_INSERT_
_INSERT_
_INSERT_
$(gettext 'Change of base:')
_INSERT_
_INSERT_
_INSERT_

$(gettext 'Hyperbolics:')
_INSERT_
_INSERT_
_INSERT_
_INSERT_
_INSERT_
_INSERT_

$(gettext 'Series:')
_INSERT_
_INSERT_
_INSERT_"> /root/.config/Puppyunits/text-ascii-2

cp -f /root/.config/Puppyunits/text-ascii-2 $WORKDIR/text-ascii

cd $WORKDIR  # now add utf8 lines to text-ascii
cat text-ascii |
while read LINE;do
echo "$LINE" | grep -q "_INSERT_"
if [ "$?" -eq 0 ];then
if [ "${LINE}" = "_INSERT_" ];then  # just the utf-8 insertion
 read LINE_utf8 < formula-utf8
sed -i '1d' formula-utf8
echo $LINE_utf8 >> combined2

elif [ "${LINE: -8}" = "_INSERT_" ];then  #  utf-8 at end
 read LINE_utf8 < formula-utf8
sed -i '1d' formula-utf8
echo "${LINE/_INSERT_/} $LINE_utf8" >> combined2
else
 read LINE_utf8 < formula-utf8   # utf-8 at beginning
sed -i '1d' formula-utf8
echo "$LINE_utf8 ${LINE/_INSERT_/}" >> combined2
fi
else
echo $LINE >> combined2  #  no utf-8 used
fi
done


###############################################
#                                             #
#               Identities                    #
#                                             #
###############################################

# for Identities  -   text-ascii-3  is used

echo "$(gettext 'Trig Identities'):
_INSERT_
_INSERT_
_INSERT_
_INSERT_
_INSERT_
_INSERT_
_INSERT_
_INSERT_
_INSERT_
_INSERT_
_INSERT_
_INSERT_

$(gettext 'Functions of double and half angles'):
_INSERT_
_INSERT_
_INSERT_
_INSERT_
_INSERT_
_INSERT_
_INSERT_
_INSERT_
_INSERT_
_INSERT_"> $WORKDIR/text-ascii-3




cd $WORKDIR  # now add utf8 lines to text-ascii
cat text-ascii-3 |
while read LINE;do
echo "$LINE" | grep -q "_INSERT_"
if [ "$?" -eq 0 ];then
if [ "${LINE}" = "_INSERT_" ];then  # just the utf-8 insertion
 read LINE_utf8 < formula-utf8
sed -i '1d' formula-utf8
echo $LINE_utf8 >> combined3

elif [ "${LINE: -8}" = "_INSERT_" ];then  #  utf-8 at end
 read LINE_utf8 < formula-utf8
sed -i '1d' formula-utf8
echo "${LINE/_INSERT_/} $LINE_utf8" >> combined3
else
 read LINE_utf8 < formula-utf8   # utf-8 at beginning
sed -i '1d' formula-utf8
echo "$LINE_utf8 ${LINE/_INSERT_/}" >> combined3
fi
else
echo $LINE >> combined3  #  no utf-8 used
fi
done
###############################################
#                                             #
#               Trignometry                   #
#                                             #
###############################################
# now make combined4  file  for trigomentry window

echo "_INSERT_
_INSERT_
$(gettext 'arc length = radius x circular measure of angle') _INSERT_
$(gettext 'area of circular sector') _INSERT_"> /root/.config/Puppyunits/text-ascii-2

cp -f /root/.config/Puppyunits/text-ascii-2 $WORKDIR/text-ascii

cd $WORKDIR  # now add utf8 lines to text-ascii
cat text-ascii |
while read LINE;do
echo "$LINE" | grep -q "_INSERT_"
if [ "$?" -eq 0 ];then
if [ "${LINE}" = "_INSERT_" ];then  # just the utf-8 insertion
 read LINE_utf8 < formula-utf8
sed -i '1d' formula-utf8
echo $LINE_utf8 >> combined4

elif [ "${LINE: -8}" = "_INSERT_" ];then  #  utf-8 at end
 read LINE_utf8 < formula-utf8
sed -i '1d' formula-utf8
echo "${LINE/_INSERT_/} $LINE_utf8" >> combined4
else
 read LINE_utf8 < formula-utf8   # utf-8 at beginning
sed -i '1d' formula-utf8
echo "$LINE_utf8 ${LINE/_INSERT_/}" >> combined4
fi
else
echo $LINE >> combined4  #  no utf-8 used
fi
done


for LABEL in 1 2 3 4 5 6 7 8;do
[  $LABEL -eq 1 ] && TEXT="$(gettext 'Return')"
[  $LABEL -eq 2 ] && TEXT="$(gettext 'Proceed')"
[  $LABEL -eq 3 ] && TEXT="$(gettext 'Convert')"
[  $LABEL -eq 4 ] && TEXT="$(gettext 'Trigonometry')"
[  $LABEL -eq 5 ] && TEXT="$(gettext 'Geometry')"
[  $LABEL -eq 6 ] && TEXT="$(gettext 'Constants')"
[  $LABEL -eq 7 ] && TEXT="$(gettext 'Algebra')"
[  $LABEL -eq 8 ] && TEXT="$(gettext 'Identities')"


X1=$(echo "$TEXT"|wc -c)  # number of letters
W=$((${X1}*6*95/31))
DISPLACE=$(($W/7))
FILL=white
[ "$TEXT" =  Convert  ] && FILL=orange

echo '<svg version="1.1"> 
      <rect
      style="fill:'$FILL';fill-opacity:.7;stroke-width:2;stroke:black;stroke-opacity:1;"
     width='\"$W\"' height="36" rx="10" ry="10" x="1" y="1"/>
           <text style="font-family:DejaVu;font-size:24;fill-opacity:1"
      x='\"$DISPLACE\"'  y="26" >
'$TEXT'
     </text>

</svg>
'>$WORKDIR/SVG_"$TEXT".svg

done

cp $WORKDIR/SVG_"$(gettext 'Proceed')".svg $WORKDIR/true.svg
cp $WORKDIR/SVG_"$(gettext 'Return')".svg $WORKDIR/false.svg


mkdir -p $WORKDIR
echo "$(gettext 'Celsius to Fahrenheit')
$(gettext 'Fahrenheit to Celsius')" > $WORKDIR/"$(gettext 'Temperature')"
cp -f $WORKDIR/"$(gettext 'Temperature')" $WORKDIR/default
echo "$(gettext 'Feet to meters')
$(gettext 'Feet to centimeters')
$(gettext 'Feet to yards')
$(gettext 'Feet to miles')
$(gettext 'Meters to inches')
$(gettext 'Meters to miles')
$(gettext 'Meters to feet')
$(gettext 'Meters to miles')
$(gettext 'Centimeters to feet')
$(gettext 'Centimeters to inches')
$(gettext 'Centimeters to yards')
$(gettext 'Yards to miles')
$(gettext 'Yards to meters')
$(gettext 'Yards to inches')
$(gettext 'Yards to feet')
$(gettext 'Miles to feet')
$(gettext 'Miles to yards')
$(gettext 'Miles to meters')
$(gettext 'Miles to kilometers')
$(gettext 'Kilometers to miles')
$(gettext 'Inches to centimeters')
$(gettext 'Inches to yards')
$(gettext 'Inches to meters')" > $WORKDIR/"$(gettext 'Distance')"
echo "$(gettext 'Square inches to square meters')
$(gettext 'Square meters to square inches')
$(gettext 'Square feet to square meters')
$(gettext 'Square meters to square feet')
$(gettext 'Square feet to hectares')
$(gettext 'Hectares to square feet')
$(gettext 'Square meters to hectares')
$(gettext 'Hectares to square meters')
$(gettext 'Square miles to hectares')
$(gettext 'Hectares to square miles')
$(gettext 'Square meters to hectares')
$(gettext 'Hectares to square meters')
$(gettext 'Square miles to square feet')
$(gettext 'Square feet to square miles')
$(gettext 'Square yards to square feet')
$(gettext 'Square feet to square yards')
$(gettext 'Square miles to square kilometers')
$(gettext 'Square kilometers to square miles')
$(gettext 'Square miles to acres')
$(gettext 'Acres to square miles')
$(gettext 'Square inches to square millimeters')
$(gettext 'Square millimeters to square inches')
$(gettext 'Square miles to square yards')
$(gettext 'Square yards to square miles')
$(gettext 'Square yards to square centimeters')
$(gettext 'Square centimeters to square yards')
$(gettext 'Square yards to square meters')
$(gettext 'Square meters to square yards')" > $WORKDIR/"$(gettext 'Area')"

echo "$(gettext 'Cubic inches to cubic meters')
$(gettext 'Cubic meters to cubic inches')
$(gettext 'Cubic feet to cubic meters')
$(gettext 'Cubic meters to cubic feet')
$(gettext 'Cubic yard to cubic meters')
$(gettext 'Cubic meters to cubic yards')
$(gettext 'Liters to cubic meters')
$(gettext 'Cubic meters to liters')
$(gettext 'Gallons(US) to cubic meters')
$(gettext 'Cubic meters to gallons(US)')
$(gettext 'Gallons(US) to liters')
$(gettext 'Liters to gallons(US)')
$(gettext 'Liters to cubic centimeters')
$(gettext 'Cubic centimeters to liters')" > $WORKDIR/"$(gettext 'Volume')"

echo "$(gettext 'Radians to Degrees')
$(gettext 'Radians to Revolutions')
$(gettext 'Revolutions to Radians')
$(gettext 'Revolutions to Degrees')
$(gettext 'Degrees to Revolutions')
$(gettext 'Degrees to Radians')" > $WORKDIR/"$(gettext 'Angle measurement')"

echo "$(gettext 'Kilograms to grams')
$(gettext 'Kilograms to ounces')
$(gettext 'Kilograms to pounds')
$(gettext 'Kilograms to stones')
$(gettext 'Kilograms to tons(short)')
$(gettext 'Kilograms to metric tons')
$(gettext 'Grams to ounces')
$(gettext 'Grams to kilograms')
$(gettext 'Grams to pounds')
$(gettext 'Ounces to grams')
$(gettext 'Ounces to kilograms')
$(gettext 'Ounces to milligrams')
$(gettext 'Ounces to pounds')
$(gettext 'Milligrams to pounds')
$(gettext 'Milligrams to ounces')
$(gettext 'Stones to pounds')
$(gettext 'Stones to kilograms')
$(gettext 'Tons(short) to pounds')
$(gettext 'Tons(short) to kilograms')
$(gettext 'Tons(short) to metric tons')
$(gettext 'Metric tons to tons(short)')
$(gettext 'Metric tons to kilograms')
$(gettext 'Metric tons to pounds')
$(gettext 'Pounds to kilograms')
$(gettext 'Pounds to ounces')
$(gettext 'Pounds to tons(short)')
$(gettext 'Pounds to stones')
$(gettext 'Pounds to ounces')
$(gettext 'Pounds to milligrams')
$(gettext 'Pounds to metric tons')" > $WORKDIR/"$(gettext 'Weight')"


echo "$(gettext 'Kilograms/cubic meter to grams/cubic centimeter')
$(gettext 'Kilograms/cubic meter to pounds/gallon(US)')
$(gettext 'Grams/cubic centimeter to kilograms/cubic meter')
$(gettext 'Grams/cubic centimeter to pounds/gallon(US)')
$(gettext 'Grams/cubic meter to pounds/gallon(US)')
$(gettext 'Pounds/gallon(US) to grams/cubic centimeter')
$(gettext 'Pounds/gallon(US) to kilograms/cubic meter')
$(gettext 'Pounds/gallon(US) to grams/cubic meter')" > $WORKDIR/"$(gettext 'Density')"

echo "$(gettext 'Pounds/square inch to pounds/square feet')
$(gettext 'Pounds/square feet to pounds/square inch')
$(gettext 'Pounds/square inch to kilograms/square centimeter')
$(gettext 'Kilograms/square centimeter to pounds/square inch')
$(gettext 'Pounds/square inch to kilograms/square meter')
$(gettext 'Kilograms/square meter to pounds/square inch')
$(gettext 'Atmospheres to kilograms/square meter')
$(gettext 'Kilograms/square meter to Atmospheres')
$(gettext 'Atmospheres to pounds/square inch')
$(gettext 'Pounds/square inch to Atmospheres')
$(gettext 'Atmospheres to kilograms/square centimeter')
$(gettext 'Kilograms/square centimeter to Atmospheres')
$(gettext 'Atmospheres to grams/square centimeter')
$(gettext 'Grams/square centimeter to Atmospheres')" > $WORKDIR/"$(gettext 'Pressure')"

echo "$(gettext 'Centimeters/sec to centimeters/hour')
$(gettext 'Centimeters/hour to centimeters/sec')
$(gettext 'Centimeters/sec to centimeters/min')
$(gettext 'Centimeters/min to centimeters/sec')
$(gettext 'Centimeters/sec to feet/hour')
$(gettext 'Centimeters/sec to feet/min')
$(gettext 'Centimeters/sec to feet/sec')
$(gettext 'Centimeters/min to feet/min')
$(gettext 'Centimeters/min to feet/sec')
$(gettext 'Feet/sec to kilometers/hour')
$(gettext 'Feet/sec to meters/hour')
$(gettext 'Feet/hour to centimeters/sec')
$(gettext 'Feet/hour to meters/min')
$(gettext 'Feet/min to centimeters/sec')
$(gettext 'Feet/hour to meters/hour')
$(gettext 'Feet/sec to centimeters/sec')
$(gettext 'Feet/sec to meters/sec')
$(gettext 'Feet/min to centimeters/min')
$(gettext 'Feet/sec to meters/min')
$(gettext 'Feet/sec to centimeters/min')
$(gettext 'Feet/hour to feet/min')
$(gettext 'Feet/min to feet/hour')
$(gettext 'Feet/hour to feet/sec')
$(gettext 'Feet/sec to feet/hour')
$(gettext 'Feet/hour to meters/sec')
$(gettext 'Feet/hour to kilometers/hour')
$(gettext 'Feet/min to kilometers/min')
$(gettext 'Feet/sec to kilometers/min')
$(gettext 'Feet/sec to kilometers/sec')
$(gettext 'Meters/sec to feet/hour')
$(gettext 'Meters/min to feet/hour')
$(gettext 'Meters/hour to feet/hour')
$(gettext 'Meters/sec to feet/sec')
$(gettext 'Meters/min to feet/sec')
$(gettext 'Meters/hour to feet/sec')
$(gettext 'Kilometers/hour to miles/hour')
$(gettext 'Kilometers/hour to feet/hour')
$(gettext 'Kilometers/hour to feet/sec')
$(gettext 'Kilometers/min to miles/min')
$(gettext 'Kilometers/min to feet/min')
$(gettext 'Kilometers/hour to knots(US)')
$(gettext 'Kilometers/min to feet/sec')
$(gettext 'Kilometers/sec to feet/sec')
$(gettext 'Kilometers/sec to miles/sec')
$(gettext 'Miles/hour to kilometers/hour')
$(gettext 'Miles/min to kilometers/min')
$(gettext 'Miles/sec to kilometers/sec')
$(gettext 'Miles/hour to knots(US)')
$(gettext 'Knots(US) to kilometers/hour')
$(gettext 'Knots(US) to miles/hour')
$(gettext 'Knots(US) to knots(UK)')
$(gettext 'Knots(UK) to knots(US)')" > $WORKDIR/"$(gettext 'Velocity')"

echo "$(gettext 'Centimeters/second squared to feet/second squared')
$(gettext 'Feet/second squared to centimeters/second squared')
$(gettext 'Centimeters/second squared to inches/second squared')
$(gettext 'Inches/second squared to centimeters/second squared')
$(gettext 'Centimeters/second squared to meters/second squared')
$(gettext 'Meters/second squared to centimeters/second squared')
$(gettext 'Feet/second squared to meters/second squared')
$(gettext 'Meters/second squared to feet/second squared')
$(gettext 'Feet/second squared to inches/second squared')
$(gettext 'Inches/second squared to feet/second squared')" > $WORKDIR/"$(gettext 'Acceleration')"

echo "$(gettext 'Watts to Horsepower')
$(gettext 'Watts to BTUs(Mean)')
$(gettext 'Watts to Kilowatts')
$(gettext 'Watts to Megawatts')
$(gettext 'Watts to Calories/sec')
$(gettext 'Horsepower to Watts')
$(gettext 'Horsepower to Kilowatts')
$(gettext 'Horsepower to BTUs(Mean)')
$(gettext 'Horsepower to Calories/sec')
$(gettext 'BTUs(Mean) to Watts')
$(gettext 'BTUs(Mean) to Kilowatts')
$(gettext 'BTUs(Mean) to Horsepower')
$(gettext 'BTUs(Mean) to Calories/sec')
$(gettext 'Kilowatts to Watts')
$(gettext 'Kilowatts to Horsepower')
$(gettext 'Kilowatts to BTUs(Mean)')
$(gettext 'Kilowatts to Megawatts')
$(gettext 'Kilowatts to Calories/sec')
$(gettext 'Megawatts to Watts')
$(gettext 'Megawatts to Kilowatts')
$(gettext 'Calories/sec to Kilowatts')
$(gettext 'Calories/sec to Watts')
$(gettext 'Calories/sec to Horsepower')
$(gettext 'Calories/sec to BTUs(Mean)')" > $WORKDIR/"$(gettext 'Power')"


echo "$(gettext 'Kiloliters/sec to Liters/sec')
$(gettext 'Liters/sec to Kiloliters/sec')
$(gettext 'Kiloliters/sec to Gallons(US)/sec')
$(gettext 'Gallons(US)/sec to Kiloliters/sec')
$(gettext 'Kiloliters/sec to Barrels(Oil)/day')
$(gettext 'Barrels(Oil)/day to Kiloliters/sec')
$(gettext 'Liters/sec to Gallons(US)/sec')
$(gettext 'Gallons(US)/sec to Liters/sec')
$(gettext 'Liters/sec to Barrels(Oil)/day')
$(gettext 'Barrels(Oil)/day to Liters/sec')
$(gettext 'Gallons(US)/sec to Barrels(Oil)/day')
$(gettext 'Barrels(Oil)/day to Gallons(US)/sec')" > $WORKDIR/"$(gettext 'Flow')"


echo "$(gettext 'Joules to BTUs(Mean)')
$(gettext 'Joules to Calories')
$(gettext 'Joules to Calories')
$(gettext 'Joules to Kilocalories')
$(gettext 'Joules to Foot-Pounds')
$(gettext 'Joules to Foot-Poundals')
$(gettext 'Calories to Kilocalories')
$(gettext 'Calories to Joules')
$(gettext 'Calories to BTUs(Mean)')
$(gettext 'Calories to Foot-Pounds')
$(gettext 'Calories to Foot-Poundals')
$(gettext 'Kilocalories to BTUs(Mean)')
$(gettext 'Kilocalories to Joules')
$(gettext 'Foot-Pounds to Joules')
$(gettext 'Foot-Poundals to Joules')
$(gettext 'Kilocalories to Calories')
$(gettext 'BTUs(Mean) to Kilocalories')
$(gettext 'BTUs(Mean) to Joules')
$(gettext 'BTUs(Mean) to Calories')
$(gettext 'Foot-Pounds to Calories')
$(gettext 'Foot-Poundals to Calories')
$(gettext 'Foot-Pounds to Foot-Poundals')
$(gettext 'Foot-Poundals to Foot-Pounds')" > $WORKDIR/"$(gettext 'Energy')"

echo "$(gettext 'Kilometers/Liter to Liters/100 Kilometers')
$(gettext 'Kilometers/Liter to Miles/Gallon(US)')
$(gettext 'Miles/Gallon(US) to Kilometers/Liter')
$(gettext 'Miles/Gallon(US) to Liters/100 Kilometers')
$(gettext 'Liters/100 Kilometers to Kilometers/Liter')
$(gettext 'Liters/100 Kilometers to Miles/Gallon(US)')" > $WORKDIR/"$(gettext 'Fuel Consumption')"

echo "$(gettext 'Dynes to Newtons')
$(gettext 'Dynes to Poundals')
$(gettext 'Dynes to Pounds force')
$(gettext 'Newtons to Dynes')
$(gettext 'Newtons to Poundals')
$(gettext 'Newtons to Pounds force')
$(gettext 'Poundals to Newtons')
$(gettext 'Poundals to Dynes')
$(gettext 'Poundals to Pounds force')
$(gettext 'Pounds force to Dynes')
$(gettext 'Pounds force to Newtons')
$(gettext 'Pounds force to Poundals')" > $WORKDIR/"$(gettext 'Force')"

echo "$(gettext 'Unit A to Unit B')
$(gettext 'Unit B to Unit A')" > $WORKDIR/"$(gettext 'Custom')"

###############################################
#                                             #
#               Choice list                   #
#                                             #
###############################################

echo "$(gettext 'Acceleration')
$(gettext 'Angle measurement')
$(gettext 'Area')
$(gettext 'Density')
$(gettext 'Distance')
$(gettext 'Energy')
$(gettext 'Flow')
$(gettext 'Force')
$(gettext 'Fuel Consumption')
$(gettext 'Power')
$(gettext 'Pressure')
$(gettext 'Temperature')
$(gettext 'Velocity')
$(gettext 'Volume')
$(gettext 'Weight')
$(gettext 'Custom')" > $WORKDIR/CHOICE_LIST
echo CHOICE_LIST > $WORKDIR/choice

export TEXT1="$(gettext 'pi') = 3.14159265
e = 2.71826183
$(gettext "Avogadro's number") (N)   = 6.023 x 10^26 /(kg mol)
$(gettext 'Bohr magneton')           =  9.274 x 10^-24 A m^2
$(gettext "Boltzmann's constant")     = 1.381 x 10^-23 J/K
$(gettext 'Stefan-Boltzmann constant')  = 5.67 x 10^-8 W/(m^2K^4)
$(gettext 'Atomic unit of charge')  = 1.602176462 x 10^-19 C
$(gettext 'Electronic rest mass')      = 9.10938215 x 10^-31 kg
$(gettext 'Electronic charge to mass ratio')   = 1.758820150 x 10^11 C/kg
$(gettext 'Faraday constant') (F)           = 9.65 x 10^7 C/(kg mol)
$(gettext 'Permeability of free space')     = 4pi x 10^-7 H/m
$(gettext 'Permittivity of free space')      = 8.854 x 10^-12 F/m
$(gettext "Planck's constant") (h)  =  6.626 x 10^-34 J s
$(gettext 'Proton mass')             = 1.672 x 10^-27 kg
$(gettext 'Proton to electron mass ratio')    = 1836.1
$(gettext 'Standard gravitational intensity')   = 9.80665 N/kg
$(gettext 'Unified atomic mass constant')= 1.66053873 x 10^-27 N m^2/kg^2
$(gettext 'Universal constant of gravity')(G) = 6.67 x 10^-11 N m^2/kg^2 
$(gettext 'Universal gas constant')      = 8.314 kJ / (kg mol K)
$(gettext 'Electronvolt')      = 1.7826 x 10^−36 kg
$(gettext 'Velocity of light in vacuum')    = 2.99792458 x 10^8 m/s
$(gettext 'Light year') = 9.4607304725808 x 10^15 m/s
$(gettext 'Speed of sound at airplane heights') = 340 to 295 m/s"

function function_switch {
   
   if [ "$(cat $WORKDIR/choice)" = CHOICE_LIST ];then
   echo "$(gettext 'Temperature')" > $WORKDIR/choice
   else
   echo CHOICE_LIST > $WORKDIR/choice
   fi
}
export -f function_switch

function function_switch2 {
   
   if [ "$LIST" = "$(gettext 'Temperature')" ];then
   echo "$(gettext 'Temperature')" > $WORKDIR/choice
   cp -f $WORKDIR/"$(cat $WORKDIR/choice)" $WORKDIR/default
   fi
   
   if [ "$LIST" = "$(gettext 'Distance')" ];then
   echo "$(gettext 'Distance')" > $WORKDIR/choice
   cp -f $WORKDIR/"$(cat $WORKDIR/choice)" $WORKDIR/default
   fi
   
   if [ "$LIST" = "$(gettext 'Area')" ];then
   echo "$(gettext 'Area')" > $WORKDIR/choice
   cp -f $WORKDIR/"$(cat $WORKDIR/choice)" $WORKDIR/default
   fi
   
      if [ "$LIST" = "$(gettext 'Volume')" ];then
   echo "$(gettext 'Volume')" > $WORKDIR/choice
   cp -f $WORKDIR/"$(cat $WORKDIR/choice)" $WORKDIR/default
   fi
         if [ "$LIST" = "$(gettext 'Angle measurement')" ];then
   echo "$(gettext 'Angle measurement')" > $WORKDIR/choice
   cp -f $WORKDIR/"$(cat $WORKDIR/choice)" $WORKDIR/default
   fi
            if [ "$LIST" = "$(gettext 'Density')" ];then
   echo "$(gettext 'Density')" > $WORKDIR/choice
   cp -f $WORKDIR/"$(cat $WORKDIR/choice)" $WORKDIR/default
   fi
            if [ "$LIST" = "$(gettext 'Weight')" ];then
   echo "$(gettext 'Weight')" > $WORKDIR/choice
   cp -f $WORKDIR/"$(cat $WORKDIR/choice)" $WORKDIR/default
   fi
              if [ "$LIST" = "$(gettext 'Pressure')" ];then
   echo "$(gettext 'Pressure')" > $WORKDIR/choice
   cp -f $WORKDIR/"$(cat $WORKDIR/choice)" $WORKDIR/default
   fi
                 if [ "$LIST" = "$(gettext 'Velocity')" ];then
   echo "$(gettext 'Velocity')" > $WORKDIR/choice
   cp -f $WORKDIR/"$(cat $WORKDIR/choice)" $WORKDIR/default
   fi
                   if [ "$LIST" = "$(gettext 'Acceleration')" ];then
   echo "$(gettext 'Acceleration')" > $WORKDIR/choice
   cp -f $WORKDIR/"$(cat $WORKDIR/choice)" $WORKDIR/default
   fi
                   if [ "$LIST" = "$(gettext 'Power')" ];then
   echo "$(gettext 'Power')" > $WORKDIR/choice
   cp -f $WORKDIR/"$(cat $WORKDIR/choice)" $WORKDIR/default
   fi
                   if [ "$LIST" = "$(gettext 'Flow')" ];then
   echo "$(gettext 'Flow')" > $WORKDIR/choice
   cp -f $WORKDIR/"$(cat $WORKDIR/choice)" $WORKDIR/default
   fi
                      if [ "$LIST" = "$(gettext 'Energy')" ];then
   echo "$(gettext 'Energy')" > $WORKDIR/choice
   cp -f $WORKDIR/"$(cat $WORKDIR/choice)" $WORKDIR/default
   fi
                      if [ "$LIST" = "$(gettext 'Fuel Consumption')" ];then
   echo "$(gettext 'Fuel Consumption')" > $WORKDIR/choice
   cp -f $WORKDIR/"$(cat $WORKDIR/choice)" $WORKDIR/default
   fi                     
   if [ "$LIST" = "$(gettext 'Force')" ];then
   echo "$(gettext 'Force')" > $WORKDIR/choice
   cp -f $WORKDIR/"$(cat $WORKDIR/choice)" $WORKDIR/default
   fi
    if [ "$LIST" = "$(gettext 'Custom')" ];then
   echo "$(gettext 'Custom')" > $WORKDIR/choice
   cp -f $WORKDIR/"$(cat $WORKDIR/choice)" $WORKDIR/default
   fi
}
export -f function_switch2


function calculation {
   COUNT=$(echo "$ENTRY"|wc -c)
SCALE=8
[ $COUNT -lt 4 ] && SCALE=4

ENTRY=${ENTRY/,/.}  #  convert a comma

   if [ -z "$ENTRY" ] ;then
       Xdialog --title "$(gettext 'Conversion')"  --ok-label "$(gettext 'OK')"  --no-cancel \
        --backtitle "\n$(gettext 'Enter a number in field and click CONVERT')" --msgbox "" 0 0
   echo "" > $WORKDIR/result
   else  # conversion starts here - CFACTOR is used for
   # all conversions except 'Celsius to Fahrenheit'

   
   if [ "$LIST" = "$(gettext 'Fahrenheit to Celsius')"  ];then
 ENTRY=$(echo "scale=$SCALE;$ENTRY -32" | bc) 
   CFACTOR=$(echo "scale=$SCALE; 5/9" | bc)  
   elif [ "$LIST" = "$(gettext 'Feet to meters')"  ];then
   CFACTOR=0.3048
   
   elif [ "$LIST" = "$(gettext 'Meters to feet')"  ];then
   CFACTOR=3.2808
      
       elif [ "$LIST" = "$(gettext 'Feet to centimeters')"  ];then
   CFACTOR=30.48
    
         elif [ "$LIST" = "$(gettext 'Centimeters to feet')"  ];then
   CFACTOR=.032808
   
   
   
                elif [ "$LIST" = "$(gettext 'Centimeters to inches')"  ];then
   CFACTOR=.39370
             elif [ "$LIST" = "$(gettext 'Inches to centimeters')"  ];then
   CFACTOR=$(echo "scale=10; 1/.39370" | bc)
                elif [ "$LIST" = "$(gettext 'Centimeters to yards')"  ];then
   CFACTOR=.010936
             elif [ "$LIST" = "$(gettext 'Yards to centimeters')"  ];then
   CFACTOR=$(echo "scale=10; 1/.010936" | bc)
                elif [ "$LIST" = "$(gettext 'Feet to yards')"  ];then
   CFACTOR=.333333
             elif [ "$LIST" = "$(gettext 'Yards to feet')"  ];then
   CFACTOR=$(echo "scale=10; 3.0000" | bc)                
             elif [ "$LIST" = "$(gettext 'Miles to feet')"  ];then
   CFACTOR=5280.0
                elif [ "$LIST" = "$(gettext 'Feet to miles')"  ];then
   CFACTOR=$(echo "scale=10; 1/5280.0" | bc)
             elif [ "$LIST" = "$(gettext 'Miles to yards')"  ];then
  CFACTOR=1760.0
                elif [ "$LIST" = "$(gettext 'Yards to miles')"  ];then
   CFACTOR=$(echo "scale=10; 1/1760.0" | bc)
             elif [ "$LIST" = "$(gettext 'Miles to meters')"  ];then
   CFACTOR=1609.347
                elif [ "$LIST" = "$(gettext 'Meters to miles')"  ];then
   CFACTOR=$(echo "scale=10; 1/1609.347" | bc)
             elif [ "$LIST" = "$(gettext 'Miles to kilometers')"  ];then
   CFACTOR=1.609347
                elif [ "$LIST" = "$(gettext 'Kilometers to miles')"  ];then
   CFACTOR=$(echo "scale=10; 1/1.609347" | bc)
             elif [ "$LIST" = "$(gettext 'Yards to meters')"  ];then
   CFACTOR=.91440
                elif [ "$LIST" = "$(gettext 'Meters to yards')"  ];then
   CFACTOR=$(echo "scale=10; 1/.91440" | bc)
             elif [ "$LIST" = "$(gettext 'Yards to inches')"  ];then
   CFACTOR=36.00
                elif [ "$LIST" = "$(gettext 'Inches to yards')"  ];then
   CFACTOR=$(echo "scale=10; 1/36.00" | bc)
                elif [ "$LIST" = "$(gettext 'Meters to inches')"  ];then
   CFACTOR=39.37
                elif [ "$LIST" = "$(gettext 'Inches to meters')"  ];then
   CFACTOR=$(echo "scale=10; 1/39.37" | bc)
   
   
   
     
            elif [ "$LIST" = "$(gettext 'Square feet to square meters')"  ];then
   CFACTOR=.09290304
           elif [ "$LIST" = "$(gettext 'Square meters to square feet')"  ];then
   CFACTOR=10.76391    
            elif [ "$LIST" = "$(gettext 'Square meters to square inches')"  ];then
   CFACTOR=1550
             elif [ "$LIST" = "$(gettext 'Square inches to square meters')"  ];then
   CFACTOR=.00064516 
             elif [ "$LIST" = "$(gettext 'Square miles to square kilometers')"  ];then
   CFACTOR=2.5899
             elif [ "$LIST" = "$(gettext 'Square kilometers to square miles')"  ];then
   CFACTOR=$(echo "scale=10; 1/2.5899" | bc)
             elif [ "$LIST" = "$(gettext 'Square miles to acres')"  ];then
   CFACTOR=639.997
             elif [ "$LIST" = "$(gettext 'Acres to square miles')"  ];then
   CFACTOR=$(echo "scale=10; 1/639.977" | bc)
             elif [ "$LIST" = "$(gettext 'Square inches to square millimeters')"  ];then
   CFACTOR=645.16
             elif [ "$LIST" = "$(gettext 'Square millimeters to square inches')"  ];then
   CFACTOR=$(echo "scale=10; 1/645.16" | bc)
             elif [ "$LIST" = "$(gettext 'Square miles to square yards')"  ];then
   CFACTOR=3097600
             elif [ "$LIST" = "$(gettext 'Square yards to square miles')"  ];then
   CFACTOR=$(echo "scale=10; 1/3097600" | bc)
             elif [ "$LIST" = "$(gettext 'Square yards to square centimeters')"  ];then
   CFACTOR=8361.27
            elif [ "$LIST" = "$(gettext 'Square centimeters to square yards')"  ];then
   CFACTOR=$(echo "scale=10; 1/8361.3" | bc)
            elif [ "$LIST" = "$(gettext 'Square yards to square meters')"  ];then
   CFACTOR=.836127
            elif [ "$LIST" = "$(gettext 'Square meters to square yards')"  ];then
   CFACTOR=$(echo "scale=10; 1/.8361" | bc)   
               elif [ "$LIST" = "$(gettext 'Acres to square feet')"  ];then
   CFACTOR=43560.17
           elif [ "$LIST" = "$(gettext 'Square feet to acres')"  ];then
   CFACTOR=$(echo "scale=10; 1/43560.17" | bc)
    
            elif [ "$LIST" = "$(gettext 'Hectares to square feet')"  ];then
   CFACTOR=107639.1
             elif [ "$LIST" = "$(gettext 'Square feet to hectares')"  ];then
    CFACTOR=$(echo "scale=10; 1/107639.1" | bc)
   
               elif [ "$LIST" = "$(gettext 'Hectares to square meters')"  ];then
   CFACTOR=10000
             elif [ "$LIST" = "$(gettext 'Square meters to Hectares')"  ];then
    CFACTOR=$(echo "scale=10; 1/10000" | bc)
               elif [ "$LIST" = "$(gettext 'Hectares to square miles')"  ];then
   CFACTOR=0.0038610
             elif [ "$LIST" = "$(gettext 'Square miles to hectares')"  ];then
    CFACTOR=$(echo "scale=10; 1/0.0038610" | bc)       
               elif [ "$LIST" = "$(gettext 'Square feet to square miles')"  ];then
   CFACTOR=$(echo "scale=10; 1/27878401" | bc)
           elif [ "$LIST" = "$(gettext 'Square miles to square feet')"  ];then
   CFACTOR=27878401
                elif [ "$LIST" = "$(gettext 'Square feet to square yards')"  ];then
   CFACTOR=$(echo "scale=10; 1/9" | bc)
           elif [ "$LIST" = "$(gettext 'Square yards to square feet')"  ];then
   CFACTOR=9  
   
    
                  elif [ "$LIST" = "$(gettext 'Radians to Degrees')"  ];then
   CFACTOR=57.29578
           elif [ "$LIST" = "$(gettext 'Degrees to Radians')"  ];then
   CFACTOR=$(echo "scale=10; 1/57.29578" | bc)
   
   
   
                     elif [ "$LIST" = "$(gettext 'Radians to Revolutions')"  ];then
   CFACTOR=$(echo "scale=10; 1/6.2831853" | bc)
           elif [ "$LIST" = "$(gettext 'Revolutions to Radians')"  ];then
   CFACTOR=6.2831853
                     elif [ "$LIST" = "$(gettext 'Revolutions to Degrees')"  ];then
   CFACTOR=360.0
           elif [ "$LIST" = "$(gettext 'Degrees to Revolutions')"  ];then
   CFACTOR=$(echo "scale=10; 1/360.0" | bc)
   
   
   
                  elif [ "$LIST" = "$(gettext 'Kilograms to grams')"  ];then
   CFACTOR=1000
                elif [ "$LIST" = "$(gettext 'Grams to kilograms')"  ];then
   CFACTOR=$(echo "scale=10; 1/1000" | bc)
                  elif [ "$LIST" = "$(gettext 'Kilograms to ounces')"  ];then
   CFACTOR=35.274
                elif [ "$LIST" = "$(gettext 'Ounces to kilograms')"  ];then
   CFACTOR=$(echo "scale=10; 1/35.274" | bc)
                  elif [ "$LIST" = "$(gettext 'Kilograms to pounds')"  ];then
   CFACTOR=2.2046
                elif [ "$LIST" = "$(gettext 'Pounds to kilgrams')"  ];then
   CFACTOR=$(echo "scale=10; 1/2.2046" | bc)
                  elif [ "$LIST" = "$(gettext 'Grams to ounces')"  ];then
   CFACTOR=.035274
                elif [ "$LIST" = "$(gettext 'Ounces to grams')"  ];then
   CFACTOR=$(echo "scale=10; 1/.035274" | bc)
                  elif [ "$LIST" = "$(gettext 'Grams to pounds')"  ];then
   CFACTOR=.0022046
                elif [ "$LIST" = "$(gettext 'Pounds to grams')"  ];then
   CFACTOR=$(echo "scale=10; 1/.0022046" | bc)
                  elif [ "$LIST" = "$(gettext 'Ounces to milligrams')"  ];then
   CFACTOR=28349.5
                elif [ "$LIST" = "$(gettext 'Milligrams to ounces')"  ];then
   CFACTOR=$(echo "scale=10; 1/28349.5" | bc)
                  elif [ "$LIST" = "$(gettext 'Pounds to ounces')"  ];then
   CFACTOR=16
                elif [ "$LIST" = "$(gettext 'Ounces to pounds')"  ];then
   CFACTOR=$(echo "scale=10; 1/16" | bc)     
                  elif [ "$LIST" = "$(gettext 'Pounds to milligrams')"  ];then
   CFACTOR=453592
                elif [ "$LIST" = "$(gettext 'Milligrams to pounds')"  ];then
   CFACTOR=$(echo "scale=10; 1/453592" | bc)
   
                     elif [ "$LIST" = "$(gettext 'Stones to pounds')"  ];then
   CFACTOR=14
                elif [ "$LIST" = "$(gettext 'Pounds to stones')"  ];then
   CFACTOR=$(echo "scale=10; 1/14" | bc)
                     elif [ "$LIST" = "$(gettext 'Stones to kilograms')"  ];then
   CFACTOR=6.3503
                elif [ "$LIST" = "$(gettext 'Kilograms to stones')"  ];then
   CFACTOR=$(echo "scale=10; 1/6.3503" | bc)   
   
                     elif [ "$LIST" = "$(gettext 'Tons(short) to metric tons')"  ];then
   CFACTOR=.9071846
                elif [ "$LIST" = "$(gettext 'Metric tons to tons(short)')"  ];then
   CFACTOR=$(echo "scale=10; 1/.9071846" | bc)
                     elif [ "$LIST" = "$(gettext 'Tons(short) to pounds')"  ];then
   CFACTOR=2000
                elif [ "$LIST" = "$(gettext 'Pounds to tons(short)')"  ];then
   CFACTOR=$(echo "scale=10; 1/2000" | bc)
                     elif [ "$LIST" = "$(gettext 'Tons(short) to kilograms')"  ];then
   CFACTOR=907.185
                elif [ "$LIST" = "$(gettext 'Kilograms to tons(short)')"  ];then
   CFACTOR=$(echo "scale=10; 1/907.185" | bc)
                     elif [ "$LIST" = "$(gettext 'Metric tons to pounds')"  ];then
   CFACTOR=2204.62
                elif [ "$LIST" = "$(gettext 'Pounds to metric tons')"  ];then
   CFACTOR=$(echo "scale=10; 1/2204.62" | bc)
                     elif [ "$LIST" = "$(gettext 'Metric tons to kilograms')"  ];then
   CFACTOR=1000
                elif [ "$LIST" = "$(gettext 'Kilograms to metric tons')"  ];then
   CFACTOR=$(echo "scale=10; 1/1000" | bc)



   
   
   
               elif [ "$LIST" = "$(gettext 'Cubic inches to cubic meters')"  ];then
   CFACTOR=.000016387064
           elif [ "$LIST" = "$(gettext 'Cubic meters to cubic inches')"  ];then
   CFACTOR=61023.982
    
            elif [ "$LIST" = "$(gettext 'Cubic feet to cubic meters')"  ];then
   CFACTOR=.028316846592
             elif [ "$LIST" = "$(gettext 'Cubic meters to cubic feet')"  ];then
   CFACTOR=$(echo "scale=8; 1/.028316846592" | bc)
               elif [ "$LIST" = "$(gettext 'Cubic yard to cubic meters')"  ];then
   CFACTOR=0.764554857984
             elif [ "$LIST" = "$(gettext 'Cubic meters to cubic yards')"  ];then
   CFACTOR=1.30795061932   
             elif [ "$LIST" = "$(gettext 'Liters to cubic meters')"  ];then
   CFACTOR=0.001
           elif [ "$LIST" = "$(gettext 'Cubic meters to liters')"  ];then
   CFACTOR=10000    
            elif [ "$LIST" = "$(gettext 'Gallons(US) to cubic meters')"  ];then
   CFACTOR=.04404883771
             elif [ "$LIST" = "$(gettext 'Cubic meters to gallons(US)')"  ];then
   CFACTOR=$(echo "scale=8; 1/.04404883771" | bc)
               elif [ "$LIST" = "$(gettext 'Gallons(US) to liters')"  ];then
   CFACTOR=3.7854111
             elif [ "$LIST" = "$(gettext 'Liters to gallons(US)')"  ];then
   CFACTOR=$(echo "scale=8; 1/3.7854111" | bc)
                  elif [ "$LIST" = "$(gettext 'Liters to cubic centimeters')"  ];then
   CFACTOR=1000
           elif [ "$LIST" = "$(gettext 'Cubic centimeters to liters')"  ];then
   CFACTOR=0.001

   
#density section   
                          elif [ "$LIST" = "$(gettext 'Kilograms/cubic meter to grams/cubic centimeter')"  ];then
   CFACTOR=.001
                elif [ "$LIST" = "$(gettext 'Grams/cubic centimeter to kilograms/cubic meter')"  ];then
   CFACTOR=$(echo "scale=10; 1000" | bc)    
                     elif [ "$LIST" = "$(gettext 'Grams/cubic centimeter to pounds/gallon(US)')"  ];then
   CFACTOR=.83454
                elif [ "$LIST" = "$(gettext 'Pounds/gallon(US) to grams/cubic centimeter')"  ];then
   CFACTOR=$(echo "scale=10; 1/.83454" | bc)
                     elif [ "$LIST" = "$(gettext 'Pounds/gallon(US) to kilograms/cubic meter')"  ];then
   CFACTOR=1198.26
                elif [ "$LIST" = "$(gettext 'Kilograms/cubic meter to pounds/gallon(US)')"  ];then
   CFACTOR=$(echo "scale=10; 1/1198.26" | bc) 
                    elif [ "$LIST" = "$(gettext 'Grams/cubic meter to pounds/gallon(US)')"  ];then
   CFACTOR=8.3454
                elif [ "$LIST" = "$(gettext 'Pounds/gallon(US) to grams/cubic meter')"  ];then
   CFACTOR=$(echo "scale=10; 1/8.3454" | bc) 
   
   # Pressure conversion
   
                    elif [ "$LIST" = "$(gettext 'Pounds/square inch to pounds/square feet')"  ];then
   CFACTOR=144
                elif [ "$LIST" = "$(gettext 'Pounds/square feet to pounds/square inch')"  ];then
   CFACTOR=$(echo "scale=10; 1/144" | bc)
                     elif [ "$LIST" = "$(gettext 'Pounds/square inch to kilograms/square centimeter')"  ];then
   CFACTOR=.0703069
                elif [ "$LIST" = "$(gettext 'Kilograms/square centimeter to pounds/square inch')"  ];then
   CFACTOR=$(echo "scale=10; 1/.0703069" | bc)
                     elif [ "$LIST" = "$(gettext 'Pounds/square inch to kilograms/square meter')"  ];then
   CFACTOR=703.069
                elif [ "$LIST" = "$(gettext 'Kilograms/square meter to pounds/square inch')"  ];then
   CFACTOR=$(echo "scale=10; 1/703.069" | bc)
                           elif [ "$LIST" = "$(gettext 'Atmospheres to kilograms/square meter')"  ];then
   CFACTOR=10332.27
                elif [ "$LIST" = "$(gettext 'Kilograms/square meter to Atmospheres')"  ];then
   CFACTOR=$(echo "scale=10; 1/10332.27" | bc)
                     elif [ "$LIST" = "$(gettext 'Atmospheres to pounds/square inch')"  ];then
   CFACTOR=14.696
                elif [ "$LIST" = "$(gettext 'Pounds/square inch to Atmospheres')"  ];then
   CFACTOR=$(echo "scale=10; 1/14.696" | bc)
                     elif [ "$LIST" = "$(gettext 'Atmospheres to kilograms/square centimeter')"  ];then
   CFACTOR=1.03323
                elif [ "$LIST" = "$(gettext 'Kilograms/square centimeter to Atmospheres')"  ];then
   CFACTOR=$(echo "scale=10; 1/1.03323" | bc)
                        elif [ "$LIST" = "$(gettext 'Atmospheres to grams/square centimeter')"  ];then
   CFACTOR=1033.23
                elif [ "$LIST" = "$(gettext 'Grams/square centimeter to Atmospheres')"  ];then
   CFACTOR=$(echo "scale=10; 1/1033.23" | bc)
   
   
   # velocity conversion
   
   
                 elif [ "$LIST" = "$(gettext 'Centimeters/sec to centimeters/hour')"  ];then
   CFACTOR=3600
                elif [ "$LIST" = "$(gettext 'Centimeters/hour to centimeters/sec')"  ];then
   CFACTOR=$(echo "scale=10; 1/3600" | bc)
                elif [ "$LIST" = "$(gettext 'Centimeters/sec to centimeters/min')"  ];then
   CFACTOR=60
                elif [ "$LIST" = "$(gettext 'Centimeters/min to centimeters/sec')"  ];then
   CFACTOR=$(echo "scale=10; 1/60" | bc)
                elif [ "$LIST" = "$(gettext 'Centimeters/sec to feet/hour')"  ];then
   CFACTOR=118.1102
                elif [ "$LIST" = "$(gettext 'Feet/hour to centimeters/sec')"  ];then
   CFACTOR=$(echo "scale=10; 1/118.1102" | bc)
                elif [ "$LIST" = "$(gettext 'Centimeters/sec to feet/min')"  ];then
   CFACTOR=1.96850
                elif [ "$LIST" = "$(gettext 'Feet/min to centimeters/sec')"  ];then
   CFACTOR=$(echo "scale=10; 1/1.96850" | bc)
                elif [ "$LIST" = "$(gettext 'Centimeters/sec to feet/sec')"  ];then
   CFACTOR=.0328084
                elif [ "$LIST" = "$(gettext 'Feet/sec to centimeters/sec')"  ];then
   CFACTOR=$(echo "scale=10; 1/.0328084" | bc)   
                elif [ "$LIST" = "$(gettext 'Centimeters/min to feet/min')"  ];then
   CFACTOR=.0328084
                elif [ "$LIST" = "$(gettext 'Feet/min to centimeters/min')"  ];then
   CFACTOR=$(echo "scale=10; 1/.0328084" | bc)
                    elif [ "$LIST" = "$(gettext 'Centimeters/min to feet/sec')"  ];then
   CFACTOR=.0005468
                elif [ "$LIST" = "$(gettext 'Feet/sec to centimeters/min')"  ];then
   CFACTOR=$(echo "scale=10; 1/.0005468" | bc)     
                  elif [ "$LIST" = "$(gettext 'Feet/hour to feet/min')"  ];then
   CFACTOR=.016667
                elif [ "$LIST" = "$(gettext 'Feet/min to feet/hour')"  ];then
   CFACTOR=$(echo "scale=10; 1/.016667" | bc)
                elif [ "$LIST" = "$(gettext 'Feet/hour to feet/sec')"  ];then
   CFACTOR=.00027778
                elif [ "$LIST" = "$(gettext 'Feet/sec to feet/hour')"  ];then
   CFACTOR=$(echo "scale=10; 1/.00027778" | bc)
                elif [ "$LIST" = "$(gettext 'Feet/hour to meters/sec')"  ];then
   CFACTOR=.00008467
                elif [ "$LIST" = "$(gettext 'Meters/sec to feet/hour')"  ];then
   CFACTOR=$(echo "scale=10; 1/.00008467" | bc)
                elif [ "$LIST" = "$(gettext 'Feet/hour to meters/min')"  ];then
   CFACTOR=.005080
                elif [ "$LIST" = "$(gettext 'Meters/min to feet/hour')"  ];then
   CFACTOR=$(echo "scale=10; 1/.005080" | bc)
                   elif [ "$LIST" = "$(gettext 'Feet/hour to meters/hour')"  ];then
   CFACTOR=.30480
                elif [ "$LIST" = "$(gettext 'Meters/hour to feet/hour')"  ];then
   CFACTOR=$(echo "scale=10; 1/.30480" | bc)
                elif [ "$LIST" = "$(gettext 'Feet/sec to meters/sec')"  ];then
   CFACTOR=.30480
                elif [ "$LIST" = "$(gettext 'Meters/sec to feet/sec')"  ];then
   CFACTOR=$(echo "scale=10; 1/.30480" | bc)
                elif [ "$LIST" = "$(gettext 'Feet/sec to meters/min')"  ];then
   CFACTOR=18.288
                elif [ "$LIST" = "$(gettext 'Meters/min to feet/sec')"  ];then
   CFACTOR=$(echo "scale=10; 1/18.288" | bc)                  
                elif [ "$LIST" = "$(gettext 'Feet/sec to meters/hour')"  ];then
   CFACTOR=1097.28
                elif [ "$LIST" = "$(gettext 'Meters/hour to feet/sec')"  ];then
   CFACTOR=$(echo "scale=10; 1/1097.28" | bc)
                elif [ "$LIST" = "$(gettext 'Kilometers/hour to miles/hour')"  ];then
   CFACTOR=.62137              
                  elif [ "$LIST" = "$(gettext 'Miles/hour to kilometers/hour')"  ];then
   CFACTOR=$(echo "scale=10; 1/.62137" | bc)
                elif [ "$LIST" = "$(gettext 'Kilometers/hour to feet/hour')"  ];then
   CFACTOR=3280.84
                elif [ "$LIST" = "$(gettext 'Feet/hour to kilometers/hour')"  ];then
   CFACTOR=$(echo "scale=10; 1/3280.84" | bc)
                elif [ "$LIST" = "$(gettext 'Kilometers/hour to feet/sec')"  ];then
   CFACTOR=.911344
                elif [ "$LIST" = "$(gettext 'Feet/sec to kilometers/hour')"  ];then
   CFACTOR=$(echo "scale=10; 1/.911344" | bc)   
                elif [ "$LIST" = "$(gettext 'Kilometers/min to miles/min')"  ];then
   CFACTOR=.621371
                elif [ "$LIST" = "$(gettext 'Miles/min to kilometers/min')"  ];then
   CFACTOR=$(echo "scale=10; 1/.621371" | bc)                 
                elif [ "$LIST" = "$(gettext 'Kilometers/min to feet/min')"  ];then
   CFACTOR=3280.84
                elif [ "$LIST" = "$(gettext 'Feet/min to kilometers/min')"  ];then
   CFACTOR=$(echo "scale=10; 1/3280.84" | bc)
                elif [ "$LIST" = "$(gettext 'Kilometers/min to feet/sec')"  ];then
   CFACTOR=54.681
                elif [ "$LIST" = "$(gettext 'Feet/sec to kilometers/min')"  ];then
   CFACTOR=$(echo "scale=10; 1/54.681" | bc)
                elif [ "$LIST" = "$(gettext 'Kilometers/sec to feet/sec')"  ];then
   CFACTOR=3280.84
                elif [ "$LIST" = "$(gettext 'Feet/sec to kilometers/sec')"  ];then
   CFACTOR=$(echo "scale=10; 1/3280.84" | bc)                  
                elif [ "$LIST" = "$(gettext 'Kilometers/sec to miles/sec')"  ];then
   CFACTOR=.621371
                elif [ "$LIST" = "$(gettext 'Miles/sec to kilometers/sec')"  ];then
   CFACTOR=$(echo "scale=10; 1/.621371" | bc)
                elif [ "$LIST" = "$(gettext 'Knots(US) to kilometers/hour')"  ];then
   CFACTOR=1.852
                elif [ "$LIST" = "$(gettext 'Kilometers/hour to knots(US)')"  ];then
   CFACTOR=$(echo "scale=10; 1/1.852" | bc)
               elif [ "$LIST" = "$(gettext 'Knots(US) to miles/hour')"  ];then
   CFACTOR=1.1578
                elif [ "$LIST" = "$(gettext 'Miles/hour to knots(US)')"  ];then
   CFACTOR=$(echo "scale=10; 1/1.1578" | bc)
                 elif [ "$LIST" = "$(gettext 'Knots(US) to knots(UK)')"  ];then
   CFACTOR=.99892
                elif [ "$LIST" = "$(gettext 'Knots(UK) to knots(US)')"  ];then
   CFACTOR=$(echo "scale=10; 1/.99892" | bc)
   
   # acceleration calculation
   
               elif [ "$LIST" = "$(gettext 'Centimeters/second squared to feet/second squared')"  ];then
   CFACTOR=.032808
                elif [ "$LIST" = "$(gettext 'Feet/second squared to centimeters/second squared')"  ];then
   CFACTOR=$(echo "scale=10; 1/.032808" | bc)
               elif [ "$LIST" = "$(gettext 'Centimeters/second squared to inches/second squared')"  ];then
   CFACTOR=.39370
                elif [ "$LIST" = "$(gettext 'Inches/second squared to centimeters/second squared')"  ];then
   CFACTOR=$(echo "scale=10; 1/.39370" | bc)
   elif [ "$LIST" = "$(gettext 'Centimeters/second squared to meters/second squared')"  ];then
   CFACTOR=.01000
                elif [ "$LIST" = "$(gettext 'Meters/second squared to centimeters/second squared')"  ];then
   CFACTOR=$(echo "scale=10; 1/.01000" | bc)
   elif [ "$LIST" = "$(gettext 'Feet/second squared to meters/second squared')"  ];then
   CFACTOR=.3048
                elif [ "$LIST" = "$(gettext 'Meters/second squared to feet/second squared')"  ];then
   CFACTOR=$(echo "scale=10; 1/.3048" | bc)
   elif [ "$LIST" = "$(gettext 'Feet/second squared to inches/second squared')"  ];then
   CFACTOR=12.00
                elif [ "$LIST" = "$(gettext 'Inches/second squared to feet/second squared')"  ];then
   CFACTOR=$(echo "scale=10; 1/12.00" | bc)
   
   #Power conversion
                elif [ "$LIST" = "$(gettext 'Watts to Horsepower')"  ];then
   CFACTOR=.00134102
                elif [ "$LIST" = "$(gettext 'Horsepower to Watts')"  ];then
   CFACTOR=$(echo "scale=10; 1/.00134102" | bc)  
                elif [ "$LIST" = "$(gettext 'Watts to BTUs(Mean)')"  ];then
   CFACTOR=.00094866
                elif [ "$LIST" = "$(gettext 'BTUs(Mean) to Watts')"  ];then
   CFACTOR=$(echo "scale=10; 1/.00094866" | bc)
                elif [ "$LIST" = "$(gettext 'Watts to Kilowatts')"  ];then
   CFACTOR=.0010
                elif [ "$LIST" = "$(gettext 'Kilowatts to Watts')"  ];then
   CFACTOR=$(echo "scale=10; 1000" | bc)
               elif [ "$LIST" = "$(gettext 'Watts to Megawatts')"  ];then
   CFACTOR=.000001
                elif [ "$LIST" = "$(gettext 'Megawatts to Watts')"  ];then
   CFACTOR=$(echo "scale=10; 1000000" | bc)
                elif [ "$LIST" = "$(gettext 'Watts to Calories/sec')"  ];then
   CFACTOR=.23906
                elif [ "$LIST" = "$(gettext 'Calories/sec to Watts')"  ];then
   CFACTOR=$(echo "scale=10; 1/.23906" | bc)   
                elif [ "$LIST" = "$(gettext 'Kilowatts to Horsepower')"  ];then
   CFACTOR=1.34102
                elif [ "$LIST" = "$(gettext 'Horsepower to Kilowatts')"  ];then
   CFACTOR=$(echo "scale=10; 1/1.34102" | bc)
                elif [ "$LIST" = "$(gettext 'Kilowatts to BTUs(Mean)')"  ];then
   CFACTOR=.947086
                elif [ "$LIST" = "$(gettext 'BTUs(Mean) to Kilowatts')"  ];then
   CFACTOR=$(echo "scale=10; 1/.947086" | bc)
                elif [ "$LIST" = "$(gettext 'Kilowatts to Megawatts')"  ];then
   CFACTOR=.0010
                elif [ "$LIST" = "$(gettext 'Megawatts to Kilowatts')"  ];then
   CFACTOR=$(echo "scale=10; 1000" | bc)
                elif [ "$LIST" = "$(gettext 'Kilowatts to Calories/sec')"  ];then
   CFACTOR=239.0585
                elif [ "$LIST" = "$(gettext 'Calories/sec to Kilowatts')"  ];then
   CFACTOR=$(echo "scale=10; 1/239.0585" | bc)   
                elif [ "$LIST" = "$(gettext 'Horsepower to BTUs(Mean)')"  ];then
   CFACTOR=.706243
                elif [ "$LIST" = "$(gettext 'BTUs(Mean) to Horsepower')"  ];then
   CFACTOR=$(echo "scale=10; 1/.706243" | bc)
               elif [ "$LIST" = "$(gettext 'Horsepower to Calories/sec')"  ];then
   CFACTOR=178.266
                elif [ "$LIST" = "$(gettext 'Calories/sec to Horsepower')"  ];then
   CFACTOR=$(echo "scale=10; 1/178.266" | bc)
                elif [ "$LIST" = "$(gettext 'BTUs(Mean) to Calories/sec')"  ];then
   CFACTOR=251.9957
                elif [ "$LIST" = "$(gettext 'Calories/sec to BTUs(Mean)')"  ];then
   CFACTOR=$(echo "scale=10; 1/251.9957" | bc)   
   
   
   
   # Flow calculate
                 elif [ "$LIST" = "$(gettext 'Kiloliters/sec to Liters/sec')"  ];then
   CFACTOR=1000.0
                elif [ "$LIST" = "$(gettext 'Liters/sec to Kiloliters/sec')"  ];then
   CFACTOR=$(echo "scale=10; .001" | bc) 
                    elif [ "$LIST" = "$(gettext 'Kiloliters/sec to Gallons(US)/sec')"  ];then
   CFACTOR=264.172
                elif [ "$LIST" = "$(gettext 'Gallons(US)/sec to Kiloliters/sec')"  ];then
   CFACTOR=$(echo "scale=10; 1/264.172" | bc)
                    elif [ "$LIST" = "$(gettext 'Kiloliters/sec to Barrels(Oil)/day')"  ];then
   CFACTOR=543439.7
                elif [ "$LIST" = "$(gettext 'Barrels(Oil)/day to Kiloliters/sec')"  ];then
   CFACTOR=$(echo "scale=10; 1/543439.7" | bc)
                    elif [ "$LIST" = "$(gettext 'Liters/sec to Gallons(US)/sec')"  ];then
   CFACTOR=.264172
                elif [ "$LIST" = "$(gettext 'Gallons(US)/sec to Liters/sec')"  ];then
   CFACTOR=$(echo "scale=10; 1/.264172" | bc)
                    elif [ "$LIST" = "$(gettext 'Liters/sec to Barrels(Oil)/day')"  ];then
   CFACTOR=543.44
                elif [ "$LIST" = "$(gettext 'Barrels(Oil)/day to Liters/sec')"  ];then
   CFACTOR=$(echo "scale=10; 1/543.44" | bc)
                    elif [ "$LIST" = "$(gettext 'Gallons(US)/sec to Barrels(Oil)/day')"  ];then
   CFACTOR=2057.1
                elif [ "$LIST" = "$(gettext 'Barrels(Oil)/day to Gallons(US)/sec')"  ];then
   CFACTOR=$(echo "scale=10; 1/2057.1" | bc)
  
  
  
    # Energy conversion
                 elif [ "$LIST" = "$(gettext 'Joules to BTUs(Mean)')"  ];then
   CFACTOR=.00094709
                elif [ "$LIST" = "$(gettext 'BTUs(Mean) to Joules')"  ];then
   CFACTOR=$(echo "scale=10; 1/.00094709" | bc) 
                elif [ "$LIST" = "$(gettext 'Joules to Calories')"  ];then
   CFACTOR=.2386623
                elif [ "$LIST" = "$(gettext 'Calories to Joules')"  ];then
   CFACTOR=$(echo "scale=10; 1/.2386623" | bc)    
                elif [ "$LIST" = "$(gettext 'Joules to Kilocalories')"  ];then
   CFACTOR=.002386623
                elif [ "$LIST" = "$(gettext 'Kilocalories to Joules')"  ];then
   CFACTOR=$(echo "scale=10; 1/.002386623" | bc)    
                elif [ "$LIST" = "$(gettext 'Joules to Foot-Pounds')"  ];then
   CFACTOR=.7375610
                elif [ "$LIST" = "$(gettext 'Foot-Pounds to Joules')"  ];then
   CFACTOR=$(echo "scale=10; 1/.7375610" | bc)    
                elif [ "$LIST" = "$(gettext 'Joules to Foot-Poundals')"  ];then
   CFACTOR=23.73042
                elif [ "$LIST" = "$(gettext 'Foot-Poundals to Joules')"  ];then
   CFACTOR=$(echo "scale=10; 1/23.73042" | bc)    
                elif [ "$LIST" = "$(gettext 'Calories to Kilocalories')"  ];then
   CFACTOR=.0010
                elif [ "$LIST" = "$(gettext 'Kilocalories to Calories')"  ];then
   CFACTOR=$(echo "scale=10; 1000.0" | bc)    
                elif [ "$LIST" = "$(gettext 'Calories to BTUs(Mean)')"  ];then
   CFACTOR=.00396831
                elif [ "$LIST" = "$(gettext 'BTUs(Mean) to Calories')"  ];then
   CFACTOR=$(echo "scale=10; 1/.00396831" | bc)   
                elif [ "$LIST" = "$(gettext 'Calories to Foot-Pounds')"  ];then
   CFACTOR=3.090395
                elif [ "$LIST" = "$(gettext 'Foot-Pounds to Calories')"  ];then
   CFACTOR=$(echo "scale=10; 1/3.090395" | bc)   
                elif [ "$LIST" = "$(gettext 'Calories to Foot-Poundals')"  ];then
   CFACTOR=99.430944
                elif [ "$LIST" = "$(gettext 'Foot-Poundals to Calories')"  ];then
   CFACTOR=$(echo "scale=10; 1/99.430944" | bc)                  
                elif [ "$LIST" = "$(gettext 'Kilocalories to BTUs(Mean)')"  ];then
   CFACTOR=3.96831
                elif [ "$LIST" = "$(gettext 'BTUs(Mean) to Kilocalories')"  ];then
   CFACTOR=$(echo "scale=10; 1/3.96831" | bc)    
                elif [ "$LIST" = "$(gettext 'Foot-Pounds to Foot-Poundals')"  ];then
   CFACTOR=32.17418
                elif [ "$LIST" = "$(gettext 'Foot-Poundals to Foot-Pounds')"  ];then
   CFACTOR=$(echo "scale=10; 1/32.17418" | bc) 
   
   
   # Fuel consumption conversion
                elif [ "$LIST" = "$(gettext 'Kilometers/Liter to Liters/100 Kilometers')"  ];then
   CFACTOR=100.0
                elif [ "$LIST" = "$(gettext 'Liters/100 Kilometers to Kilometers/Liter')"  ];then
   CFACTOR=$(echo "scale=10; .01" | bc)   
                elif [ "$LIST" = "$(gettext 'Kilometers/Liter to Miles/Gallon(US)')"  ];then
   CFACTOR=2.3521
                elif [ "$LIST" = "$(gettext 'Miles/Gallon(US) to Kilometers/Liter')"  ];then
   CFACTOR=$(echo "scale=10; 1/2.3521" | bc) 
                elif [ "$LIST" = "$(gettext 'Miles/Gallon(US) to Liters/100 Kilometers')"  ];then
   CFACTOR=235.21
                elif [ "$LIST" = "$(gettext 'Liters/100 Kilometers to Miles/Gallon(US)')"  ];then
   CFACTOR=$(echo "scale=10; 1/235.21" | bc) 
   
   # Force conversion
   
                elif [ "$LIST" = "$(gettext 'Dynes to Newtons')"  ];then
   CFACTOR=.00001
                elif [ "$LIST" = "$(gettext 'Newtons to Dynes')"  ];then
   CFACTOR=$(echo "scale=10; 10000" | bc) 
                elif [ "$LIST" = "$(gettext 'Dynes to Poundals')"  ];then
   CFACTOR=.00007233
                elif [ "$LIST" = "$(gettext 'Poundals to Dynes')"  ];then
   CFACTOR=$(echo "scale=10; 13825.5" | bc) 
                elif [ "$LIST" = "$(gettext 'Dynes to Pounds force')"  ];then
   CFACTOR=.0000022481
                elif [ "$LIST" = "$(gettext 'Pounds force to Dynes')"  ];then
   CFACTOR=$(echo "scale=10; 444822.2" | bc) 
                elif [ "$LIST" = "$(gettext 'Newtons to Poundals')"  ];then
   CFACTOR=7.23301
                elif [ "$LIST" = "$(gettext 'Poundals to Newtons')"  ];then
   CFACTOR=$(echo "scale=10; 1/7.23301" | bc)    
                  elif [ "$LIST" = "$(gettext 'Newtons to Pounds force')"  ];then
   CFACTOR=.2248089
                elif [ "$LIST" = "$(gettext 'Pounds force to Newtons')"  ];then
   CFACTOR=$(echo "scale=10; 1/.2248089" | bc)
                  elif [ "$LIST" = "$(gettext 'Poundals to Pounds force')"  ];then
   CFACTOR=.031081
                elif [ "$LIST" = "$(gettext 'Pounds force to Poundals')"  ];then
   CFACTOR=$(echo "scale=10; 1/.031081" | bc)
   
   
   
                elif [ "$LIST" = "$(gettext 'Unit A to Unit B')"  ];then
   CFACTOR=$(cat /root/.config/Puppyunits/custom)
                elif [ "$LIST" = "$(gettext 'Unit B to Unit A')"  ];then
   CFACTOR=$(echo "scale=10; 1/$(cat /root/.config/Puppyunits/custom)" | bc)
   
   
   fi  
     
   CALCULATION=$(echo "scale=$SCALE; $ENTRY * $CFACTOR " | bc)
   [ "${CALCULATION:0:6}" = ".99999" ] && CALCULATION=1.0  
   echo "$CALCULATION"  >  $WORKDIR/result
   
   
   if [ "$LIST" = "$(gettext 'Celsius to Fahrenheit')"  ];then
   CALCULATION=$(echo "scale=$SCALE; $ENTRY *9 /5 + 32" | bc)
      [ "${CALCULATION:0:6}" = ".99999" ] && CALCULATION=1.0         
   echo "$CALCULATION"  >  $WORKDIR/result
   fi
   fi
}
export -f calculation

function function_window {
echo '<window border-width="20" title="'$(gettext 'Geometry')'">
<vbox>
<edit>			
			<width>550</width>
			<height>400</height>	
		    <input file>'$WORKDIR'/combined</input>	
</edit>
<hbox><button cancel></button></hbox>
</vbox>
</window>
'|gtkdialog -s
}
export -f function_window

function function_window2 {
echo '<window border-width="20" title="'$(gettext 'Algebra')'">
<vbox>
<edit>			
			<width>550</width>
			<height>400</height>	
		    <input file>'$WORKDIR'/combined2</input>	
</edit>
<hbox><button cancel></button></hbox>
</vbox>
</window>
'|gtkdialog -s
}
export -f function_window2
function function_window3 {
echo '<window border-width="20" title="'$(gettext 'Identities')'">
<vbox>
<edit>			
			<width>550</width>
			<height>400</height>	
		    <input file>'$WORKDIR'/combined3</input>	
</edit>
<hbox><button cancel></button></hbox>
</vbox>
</window>
'|gtkdialog -s
}
export -f function_window3


function function_window4 {
echo ' <window title="'$(gettext 'Trigonometry')'">
<vbox>
<text>		
	<input file>'$WORKDIR'/combined4</input>
</text>
<pixmap>
	<variable>PIX</variable>	
	<input file>/root/.config/Puppyunits/trigonometry.svg</input>	
</pixmap>
</vbox>
</window>
'|gtkdialog -s
}
export -f function_window4


function function_custom {	
if [  "$LIST" = "$(gettext 'Custom')" ];then 
Xdialog --title "$(gettext 'Conversion')"   --ok-label "$(gettext 'OK')" --no-cancel  --backtitle "\n$(gettext 'Conversion factor\nUnit A to Unit B')"\
          --inputbox "$(gettext 'Current factor'): $(cat /root/.config/Puppyunits/custom)\n" 0 0 "$(cat /root/.config/Puppyunits/custom)" \
           0 0	 2>/tmp/temp$$
CFACTOR="$(cat  /tmp/temp$$)"
CFACTOR=${CFACTOR/,/.}  #  convert a comma
rm -f /tmp/temp$$
  [ -z "$CFACTOR" ] &&   CFACTOR=$(cat /root/.config/Puppyunits/custom)
  echo "$CFACTOR" > /root/.config/Puppyunits/custom
 fi
}
export -f function_custom


export MAIN_DIALOG='
<window title="Puppy Units '$VERSION'" border-width="20">
<hbox>

     <vbox space-expand="true" space-fill="true">
            <list selected-row="0">
            <variable>LIST</variable>
            <height>370</height>
            <width>350</width>            
            <input file>'$WORKDIR'/default</input>                                 
            </list>
    <hbox homogeneous="true">     
                 <hbox width-request="140">
                      <entry>					
					  <variable>ENTRY</variable>					
				      </entry>
				 </hbox>        
   <pixmap>
	     <variable>PIXMAP</variable>
		<input file stock="gtk-go-forward"></input>
   </pixmap>
                <hbox width-request="140">
                      <entry activates_default="true">
                      <input file>'$WORKDIR'/result</input>					
					  <variable>RESULT</variable>					
				      </entry>
				</hbox>
    </hbox>
     </vbox>
     
     
     
     
<vseparator></vseparator>
     <vbox>
     
              <button>
                     <input file>'$WORKDIR/SVG_$(gettext 'Trigonometry').svg'</input>
                     <action>function_window4 &</action>
              </button> 
               <button>
                     <input file>'$WORKDIR/SVG_$(gettext 'Geometry').svg'</input>
                     <action>function_window &</action>
              </button>              
              <button>
                     <input file>'$WORKDIR/SVG_$(gettext 'Algebra').svg'</input>
                    <action>function_window2 &</action>
                </button>
                <button>
                     <input file>'$WORKDIR/SVG_$(gettext 'Identities').svg'</input>
                     <action>function_window3 &</action>
              </button>
              <button>
                     <input file>'$WORKDIR/SVG_$(gettext 'Constants').svg'</input>
                     <action>Xdialog --title "'$(gettext 'Constants')'" --left --ok-label "'$(gettext 'OK')'" --msgbox "$TEXT1 $TEXT2" 0 0 &</action>
              </button>              
              <button>
                     <variable>BUTTON</variable>
                     <input file>'$WORKDIR/SVG_$(gettext 'Convert').svg'</input>
                     <action>calculation</action>
                     <action>refresh:RESULT</action>
              </button>            
             <text space-expand="true"><label>""</label></text>
                <togglebutton  can-default="true" has-default="true" active="true">
                       <variable>togglebutton</variable>                    
                  <action>ln -sf '$WORKDIR'/"$togglebutton".svg '$WORKDIR'/togglebutton.svg</action>
                  <action>function_switch2</action>                  
                  <action>cp -f '$WORKDIR'/"$(cat $WORKDIR/choice)" '$WORKDIR'/default</action>                  
                  <action>function_switch</action> 
                  <action>function_custom</action>                 
                     <action>if true hide:BUTTON</action>
                     <action>if false show:BUTTON</action> 
                      <action>if true hide:PIXMAP</action>
                     <action>if false show:PIXMAP</action>
                      <action>if true hide:ENTRY</action>
                     <action>if false show:ENTRY</action>
                     <action>if true hide:RESULT</action>
                     <action>if false show:RESULT</action>                                                   
                  <action>clear:LIST</action>
                  <action>refresh:LIST</action>
                  <action>refresh:togglebutton</action>   
                    <action>clear:RESULT</action> 
                    <action>clear:ENTRY</action>                              
                  <input file>'$WORKDIR'/togglebutton.svg</input>
            </togglebutton>   
     </vbox>
</hbox>

</window>'

gtkdialog --program=MAIN_DIALOG 

rm -rf $WORKDIR

echo "Program has finished."
